/*
 * FILE								: key.c
 * DESCRIPTION				: This file is iCore key driver.
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 * --------------------
 * Rev								: 0.00
 * Date								: 03/05/2012
 *
 * create.
 * --------------------
 */

//---------------- Include files ------------------------//

#include "..\include\hardware.h"
#include "..\include\systick.h"
#include "..\include\key.h"
#include "..\include\usart.h"

#include <stdlib.h>
#include <string.h>

//---------------- Function Prototype -------------------//

static int initialize(void);

//---------------- Variable -----------------------------//

KEY_T key = {
	.initialize = initialize,
};


//-----------------Function------------------------------//

/*
 * Name										: initialize
 * Description						: ---
 * Author									: XiaomaGee.
 *
 * History
 * ----------------------
 * Rev										: 0.00
 * Date										: 03/05/2012
 *
 * create.
 * ----------------------
 */
static int
initialize(void)
{
	//PD2 as interrupt

	GPIOD->CRL.B.MODE2 = 0;  //ģʽ
	GPIOD->CRL.B.CNF2 = 2; //
	GPIOD->ODR.B.IO2 = 1; //


	//ⲿж
	AFIO->EXTICR1.B.EXTI2 = 3; //PD2ж

	EXTI->IMR.B.MR2 = 1; //2ϵж
	EXTI->FTSR.B.TR2 = 1; //½ش

	NVIC->ISER1.B.EXTI2 = 1;
	NVIC->IPR3.B.EXTI2 = 0;

	return 0;
}
/*
 * Name										: read
 * Description						: ---
 * Author									: XiaomaGee.
 *
 * History
 * ----------------------
 * Rev										: 0.00
 * Date										: 03/05/2012
 *
 * create.
 * ----------------------
 */

void EXTI2_IRQHandler(void)
{
	static int i = 0;

	if (i++ % 2) LED_ON;
	else LED_OFF;

	usart1.printf("Hello iCore\r\n");

	EXTI->PR.B.PR2 = 1; //CLEAR
}

